<template>
  <div>
    <hr />
    <section class="fr-accordion">
      <div class="fr-accordion__title">
        <button
          class="fr-accordion__btn"
          aria-expanded="false"
          :aria-controls="historyId"
        >
          Historique des changements
        </button>
      </div>
      <div
        :id="historyId"
        class="fr-collapse"
      >
        <HistoryTable
          v-if="history"
          :history="history"
          :route-with-params="routeWithParams"
        />
      </div>
    </section>
  </div>
</template>

<script setup>
  import { CREATE_ACTION } from '~/utils/constants/history'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { getRandomId } from '~~/utils/random'

  const { $apiRequest } = useNuxtApp()

  const props = defineProps({
    id: { type: String, default: null },
    collection: { type: String, default: null },
    /**
     * Used for the history of a collection
     * It defines the URL base to access the item within the application
     */
    routeWithParams: { type: Function, default: null }
  })

  const historyId = computed(() => `history-${props.id || props.collection}`)

  const { data: history } = useLazyAsyncData(
    getRandomId('history'),
    loadHistory,
    {
      server: false
    }
  )

  async function loadHistory() {
    if (props.id) return await loadHistoryFromId(props.id)
    if (props.collection) {
      return await loadHistoryFromCollection(props.collection)
    }
  }

  async function loadHistoryFromId(id) {
    return await loadHistoryWithFilter({ item: { _eq: id } })
  }

  async function loadHistoryFromCollection(collection) {
    return await loadHistoryWithFilter({
      collection: { _eq: collection },
      action: { _eq: CREATE_ACTION }
    })
  }

  async function loadHistoryWithFilter(filter) {
    const fields = [
      'action',
      'timestamp',
      'user.id',
      'user.first_name',
      'user.last_name',
      'revisions.delta',
      'revisions.parent',
      'id',
      'item'
    ]
    const res = await $apiRequest(
      '/activity',
      {},
      {
        fields,
        filter,
        sort: [{ field: 'timestamp', sort: '-' }]
      }
    )

    if (res.status === 200) return res.data.data
    throw new Error(errorResponseMessage(res))
  }
</script>

<style lang="scss" scoped>
  @use '~/assets/style/variables' as *;

  $border-radius: 1.5rem;

  .fr-accordion {
    &::before {
      box-shadow: none;
      border: solid 1px var(--border-default-grey);
      border-radius: $border-radius;
    }

    .fr-accordion__btn {
      border-top-left-radius: $border-radius;
      border-top-right-radius: $border-radius;
      transition: border-radius 0.3s;
      color: $primary;

      &[aria-expanded='false'] {
        border-bottom-left-radius: $border-radius;
        border-bottom-right-radius: $border-radius;
      }
    }

    .fr-collapse {
      padding: 0;
      margin: 0;
    }
  }
</style>
